# G-code

[![pipeline status](https://gitlab.com/jimsy/gcode/badges/main/pipeline.svg)](https://gitlab.com/jimsy/gcode/commits/main)
[![Hex.pm](https://img.shields.io/hexpm/v/gcode.svg)](https://hex.pm/packages/gcode)
[![Hippocratic License HL3-FULL](https://img.shields.io/static/v1?label=Hippocratic%20License&message=HL3-FULL&labelColor=5e2751&color=bc8c3d)](https://firstdonoharm.dev/version/3/0/full.html)

`gcode` is an Elixir library for parsing and generating [G-code](https://en.wikipedia.org/wiki/G-code), which is a common language for working with CNC machines and 3D printers.

## Installation

This package is [available in Hex](https://hex.pm/packages/gcode).

You can install it from git by adding `{:gcode, "~> 1.0.0"}` to your dependencies.

## Documentation

Documentation for the main branch of this package is always available [on gitlab pages](https://jimsy.gitlab.io/gcode), and released versions are published [on Hexdocs](https://hexdocs.pm/gcode).

## Contributing

This project uses the wonderful [git_ops](https://hex.pm/packages/git_ops) package to automate releases and as such requires the use of [Conventional Commits](https://www.conventionalcommits.org/en/v1.0.0/).  Feel free to open issues and pull requests.

## License

This software is licensed under the terms of the
[HL3-FULL](https://firstdonoharm.dev), see the `LICENSE.md` file included with
this package for the terms.

This license actively proscribes this software being used by and for some
industries, countries and activities.  If your usage of this software doesn't
comply with the terms of this license, then [contact me](mailto:james@harton.nz)
with the details of your use-case to organise the purchase of a license - the
cost of which may include a donation to a suitable charity or NGO.
